<?php
namespace NeosRulez\React\CookieOptIn\DataSource;

use Neos\Flow\Annotations as Flow;
use Neos\Flow\Persistence\PersistenceManagerInterface;
use Neos\Utility\TypeHandling;
use Neos\Neos\Service\DataSource\AbstractDataSource;
use Neos\ContentRepository\Domain\Model\NodeInterface;

class CookieDataSource extends AbstractDataSource {

    /**
     * @Flow\Inject
     * @var \NeosRulez\React\CookieOptIn\Service\MetadataService
     */
    protected $metadataService;

    /**
     * @var array
     */
    protected $settings;

    /**
     * @param array $settings
     * @return void
     */
    public function injectSettings(array $settings) {
        $this->settings = $settings;
    }

    /**
     * @var string
     */
    protected static $identifier = 'neosrulez-react-cookieoptin-cookiegroups';

    /**
     * @inheritDoc
     */
    public function getData(NodeInterface $node = null, array $arguments = array())
    {
        $options = [];
        $metadata = $this->metadataService->loadMetaData();
        foreach ($metadata as $i => $option) {
            $options[] = [
                'label' => $option['label'],
                'value' => $i
            ];
        }
        return $options;
    }

}
